/*
 * Component: utils
 *
 * Description:
 *    DataBase interface definition for ImageMedical PB-SCP
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 */
#ifndef __DBIM_H_INCLUDED__
#define __DBIM_H_INCLUDED__

#include <string.h>

#include <mysql.h>

//  ****************************  StringBuffer  ****************************
class StringBuffer
{
public:
	StringBuffer()  {
		str = new char[1];
		*str = '\0';
	}
	
	~StringBuffer() {
		delete[] str;
	}
	
	inline char *get() {
		return str;
	}
	
	char *truncate( const unsigned int len );
	
	inline char *truncate(const char *suffix) {
		return truncate( strlen(suffix) );
	}
	
	inline int isEpmty() {
		return !(*str);
	}
	
	StringBuffer& replace(const char original, const char changeTo);
	
	StringBuffer& set(const char *content);
	
	StringBuffer& append(const char *appending);
	
	inline StringBuffer& append(StringBuffer &appending) {
		return append(appending.get());
	}
	
	StringBuffer& append(StringBuffer *appending);
	
protected:
	char  *str;
};


//  ****************************  DB_Query  ****************************
class DB_Query
{
public:

	DB_Query();
	
	~DB_Query();
	
	int init();
	
	int isReady();
	
	int newQuery( const char *selectStatement );

	int executeUpdate( const char *updateStatement );

	int countQuery();

	int affectedRows();

	int nextRecord();

	char *getField( const unsigned int columnIdx );
	
	void copyFieldValue( const unsigned int columnIdx, char ** value );
	
	inline char * getErrMsg() {
		return errMsg.get();
	}

protected:
	StringBuffer  errMsg;
	MYSQL      *con;
	MYSQL_RES  *res;
	MYSQL_ROW  rec;
};

#endif // __DBIM_H_INCLUDED__
